

var SaveAsPdf = function( arrTranslations ) {

    this.arrTranslations = arrTranslations;

    var me = this;

    this.onReady = function( ) {
        var $elemPdfDialog = $("#js-pdf-dialog");

        $elemPdfDialog.removeClass('offset');

        $elemPdfDialog.dialog({
            resizable: false,
            dialogClass: 'txtcenter',
            modal: true,
            autoOpen: false,
            closeOnEscape: false,
            draggable: false,
            width: 300
        });

        //On annule le lien href de la balise a
        $('.actipdf').on( 'click', function(e){
            e.preventDefault();

            me.generePDF( $elemPdfDialog, $(this).data('url-generate'), $(this).data('url-download'));
        });
    };


    // Génère un fichier PDF à partir de la page web actuelle
    this.generePDF = function( $elemPdfDialog, strGeneratePdf, strDownloadPdf ) {

        var srcImg = '';
        if(typeof _baseURL !== 'undefined') {
            srcImg = _baseURL + '/bundles/actimagesaveaspdf/images/load.gif';
        }

        $elemPdfDialog.html('<img src="' + srcImg + '" alt="' + me.arrTranslations['saveaspdf.titleImgLoading'] + '"/><br/><p>' + me.arrTranslations['saveaspdf.labelLoading'] + '</p>');

        //On affiche une boite de dialogue demandant à l'utilisateur de patienter
        $elemPdfDialog.dialog('open');
        $elemPdfDialog.parent().find(".ui-dialog-titlebar-close").hide();

        $.getJSON(
            strGeneratePdf,
            function( data ) {}
        ).success(function(data) {
            $elemPdfDialog.dialog('close');

            //Si il n'y a eu aucune erreur durant la génération du PDF
            if(typeof data.success !== 'undefined' && data.success == true) {

                //Téléchargement du fichier PDF
                window.location.href = strDownloadPdf;
            }

        }).fail(function(jXhr) {
            var data = jXhr.responseJSON;

            $elemPdfDialog.parent().find(".ui-dialog-titlebar-close").show();

            //Affiche un message d'erreur
            if( data.message !== undefined )
                $elemPdfDialog.html(data.message);

        });
    }
};


